//Saving and reading the net seems to work.
//Might want to try to integrate with the application window next.
import java.io.*;
import java.util.*;
import java.net.*;  //for URL

public class Net {
   int CANTStep = 0;
   public static Neuron Neurons[];
   public int Cols;
   public  int Rows;

   //parameters to set via interface
   public static boolean LearningOn = false;
   public static boolean CompensatoryLearningOn = true;
   public static boolean SpontaneousActivationOn = false;
   public static boolean AssociationTest=false;
   public static boolean AllowRunOn=true;
   public static boolean ChangeEachTime=false;
   public static boolean NeuronsFatigue=true;
   public static boolean RecordingActivation=true;
   public static String NetFileName="Net.dat";
   
private Inppat printInpPat;

//Neurons to stimulate via external activation
public static int NeuronsToStimulate=100;

//global constants constants (should be read)
public static double ACTIVATION_THRESHOLD = 0.5;
public static double CONNECTIVITY = 0.8;
public static double Conn_Str = 1;  
public static int INHIBITORY_SYNAPSES = 20;
int NUMBERCYCLES = 100;

//private DataOutputStream outputFile;
//private DataInputStream inputFile;

public Net () {}

public Net(int cols, int rows)
{
   Cols = cols;
   Rows = rows;
   System.out.print ( rows + " " + cols + " row cols\n");
   Initialize();
   
   FireNodes = new int[1000][Size()];
   printInpPat = new Inppat(15,cols,rows);
}

public void assert(boolean test)
{  int x = -1;
   if (! test) x = (1 / (1 +x));
}

public void SetLearningOn(boolean Value) {LearningOn = Value;}

public int Size() { return (Cols*Rows);}

public void Initialize()
{
   if (CANT20.READPARAMETERS)
   {
      if (CANT20.ApplicationNotApplet)
         ReadParameters();
      else
         ServerReadParameters(CANT20.ParameterURL);
   } 

   Neuron.GTotalNeurons = 0;

   //create the neurons
   Neurons = new Neuron [ Cols*Rows ];
   //You have to initialize each of the neurons
   for (int i = 0 ; i < Cols*Rows; i++) {
     Neurons[i] = new Neuron ();
   }
}


public void ServerReadParameters(URL HomeURL) {	
   InputStream inputFile;
   int inputLength;
   byte inputBytes[];
   String inputLine, paramString;
   StringTokenizer tokenizedLine;
   Float tempFloat;
   Double tempDouble;

   inputBytes = new byte[1000];

   try {
   	  inputFile = HomeURL.openStream();
	  inputLength = inputFile.read(inputBytes);
	  inputLine = new String(inputBytes);
      tokenizedLine = new StringTokenizer(inputLine);

   	  paramString=tokenizedLine.nextToken();
   	  Neuron.LIKELIHOOD_OF_INHIBITORY_NEURON =  
   	     Integer.parseInt(paramString);

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempFloat = new Float(paramString);
	  Neuron.DECAY = tempFloat.floatValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempFloat = new Float(paramString);
   	  Neuron.FATIGUE_RATE = tempFloat.floatValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempFloat = new Float(paramString);
   	  Neuron.FATIGUE_RECOVERY_RATE = tempFloat.floatValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempFloat = new Float(paramString);
   	  Neuron.LEARNING_RATE = tempFloat.floatValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  Neuron.COMPENSATORY_DIVISOR =  Integer.parseInt(paramString);
   	
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempFloat = new Float(paramString);
   	  Neuron.SATURATIONBASE = tempFloat.floatValue();
   	
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempDouble = new Double(paramString);
   	  Neuron.AXONAL_STRENGTH_MEDIAN =  tempDouble.doubleValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempDouble = new Double(paramString);
   	  ACTIVATION_THRESHOLD =  tempDouble.doubleValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempDouble = new Double(paramString);
   	  CONNECTIVITY = tempDouble.doubleValue();

   	  paramString=tokenizedLine.nextToken();
   	  paramString=tokenizedLine.nextToken();
   	  tempDouble = new Double(paramString);
   	  Conn_Str = tempDouble.doubleValue();

      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
	  int LearningValue = Integer.parseInt(paramString);
	  if (LearningValue == 0) LearningOn = false;
	  else 
	  {
	  	 LearningOn=true;
	     if (LearningValue == 1) CompensatoryLearningOn = false;
	     else CompensatoryLearningOn = true;
	  }

      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      NeuronsToStimulate =  Integer.parseInt(paramString);

      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      if (paramString.equals("true"))
        ChangeEachTime = true;
      else ChangeEachTime = false; 
//      System.out.print ( paramString + " " + ChangeEachTime + "\n");

      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      if (paramString.equals("true"))
        NeuronsFatigue = true;
      else NeuronsFatigue = false; 

      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      paramString=tokenizedLine.nextToken();
      CANT20.inputPattern.CYCLESPERRUN =  Integer.parseInt(paramString);

      inputFile.close();
      }
	  
   catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);
   }
}

public static void ReadParameters() {
   DataInputStream Input;  
   String inputLine,paramString;
   StringTokenizer tokenizedLine;
   int LearningValue;
   
   
     try {      
	   Input = new DataInputStream(
       new FileInputStream(CANT20.ParameterFileName));

       inputLine = Input.readLine();
	   tokenizedLine = new StringTokenizer(inputLine);
	   paramString=tokenizedLine.nextToken();
       Neuron.LIKELIHOOD_OF_INHIBITORY_NEURON =  
	   Integer.parseInt(paramString);

	   inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.DECAY =  Float.parseFloat(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.FATIGUE_RATE =  Float.parseFloat(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.FATIGUE_RECOVERY_RATE =  Float.parseFloat(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.LEARNING_RATE =  Float.parseFloat(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.COMPENSATORY_DIVISOR =  Integer.parseInt(paramString);
     
       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.SATURATIONBASE =  Float.parseFloat(paramString);
     
       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Neuron.AXONAL_STRENGTH_MEDIAN =  Double.parseDouble(paramString);
 
       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       ACTIVATION_THRESHOLD =  Double.parseDouble(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       CONNECTIVITY = Double.parseDouble(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       Conn_Str =  Double.parseDouble(paramString);

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       LearningValue =  Integer.parseInt(paramString);
	   if (LearningValue == 0) LearningOn=false;
	   else 
	   {
	   	   LearningOn=true;
		   if (LearningValue == 1) CompensatoryLearningOn = false;
      	   else CompensatoryLearningOn = true;
	   }

       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       NeuronsToStimulate =  Integer.parseInt(paramString);
	   
       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       if (paramString.equals("true"))
         ChangeEachTime = true;
       else ChangeEachTime = false; 
       inputLine =  Input.readLine();
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       if (paramString.equals("true"))
         NeuronsFatigue = true;
       else NeuronsFatigue = false; 
	   
	   inputLine =  Input.readLine();
	   tokenizedLine = new StringTokenizer(inputLine);
	   paramString=tokenizedLine.nextToken();
	   CANT20.inputPattern.CYCLESPERRUN =  Integer.parseInt(paramString);
      }

     catch (IOException e) {
      System.err.println("Can not read parameters\n" +
                           e.toString());
       }
}

public static void WriteParameters() {
   int LearningValue;
   DataOutputStream OutputFile;
   String outString="";
   
   outString=Integer.toString(Neuron.LIKELIHOOD_OF_INHIBITORY_NEURON);
   outString=outString + " Likelihood of Inhibitory Neuron\n";
   outString=outString + Float.toString(Neuron.DECAY);
   outString=outString + " Decay\n";
   outString=outString + Float.toString(Neuron.FATIGUE_RATE);
   outString=outString +" Fatigue Rate\n";
   outString=outString + Float.toString(Neuron.FATIGUE_RECOVERY_RATE);
   outString=outString + " Fatigue Recovery RAte\n";
   outString=outString + Float.toString(Neuron.LEARNING_RATE);
   outString=outString + " Learning Rate\n";
   outString=outString + Integer.toString(Neuron.COMPENSATORY_DIVISOR);
   outString=outString + " Compensatory Divisor\n";
   outString=outString + Float.toString(Neuron.SATURATIONBASE);
   outString=outString + " Saturation Base\n";
   outString=outString + Double.toString(Neuron.AXONAL_STRENGTH_MEDIAN);
   outString=outString + " Axonal Strength Median\n";
   outString=outString + Double.toString(Net.ACTIVATION_THRESHOLD);
   outString=outString + " Activation Threshold\n";
   outString=outString + Double.toString(Net.CONNECTIVITY);
   outString=outString + " Connectivity\n";
   outString=outString + Double.toString(Net.Conn_Str);
   outString=outString + " Connection Strength\n";
   if (!LearningOn) LearningValue = 0;
   else if (!CompensatoryLearningOn) LearningValue = 1;
   else LearningValue = 2;
   outString=outString + Integer.toString(LearningValue);
   outString=outString + " Learning On\n";
   outString=outString + Integer.toString(NeuronsToStimulate);
   outString=outString + " Neurons To Stimulate\n";
   outString=outString + ChangeEachTime;
   outString=outString + " Change Each Time\n";
   outString=outString + NeuronsFatigue;
   outString=outString + " Neurons Fatigue\n";
   outString=outString + CANT20.inputPattern.CYCLESPERRUN;
   outString=outString + " Cycles Per Run\n";

   try {      OutputFile = new DataOutputStream(
      new FileOutputStream(CANT20.ParameterFileName));
      OutputFile.writeBytes(outString);
      OutputFile.close();
      }
   catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);
   }

}


public void ServerReadNet(URL HomeURL) {	
   InputStream inputFile;
   InputStreamReader inputSR;
   LineNumberReader inputLNFile;
   String inputLine, paramString;
   StringTokenizer tokenizedLine;

   try {
   	  inputFile = HomeURL.openStream();
	  inputSR = new InputStreamReader(inputFile);
      inputLNFile = new LineNumberReader (inputSR);

      inputLine = inputLNFile.readLine();
      Rows=Integer.parseInt(inputLine);
      System.out.print ( Integer.toString(Rows) + "\n");

      inputLine= inputLNFile.readLine();
      Cols=Integer.parseInt(inputLine);
      System.out.print ( Integer.toString(Cols) + "\n");

      Initialize();

      for (int cNeurons=0; cNeurons < (Rows*Cols); cNeurons++) {
      	Neurons[cNeurons].Read(inputLNFile);
      }

      inputFile.close();
      }
	  
   catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);
   }
}


private DataOutputStream Output;   
public void CreateNet_dat() {

  try {    Output = new DataOutputStream(new FileOutputStream("Net.dat"));

    Output.writeBytes( "50" +"\n"+ "50" +"\n");
     
	int AAAA = 625;   //The number of neurons in each subset.
	int NoOfConnection = 79;
	double WeightIn = 0.12 ;  //The weights from Set A to A.
	double WeightOut = 0.2 ; //The weights from Set A to B.

    //Create A pattern  (A neurons)
    for ( int i=0; i < AAAA ; i++ )  {
      Output.writeBytes( Integer.toString(i) + " " + "Neuron" + "\n");

      for (int j=0; j< NoOfConnection ; j++ ) {
         if (j==0)
         Output.writeBytes(  "80"+ " " + "Axons"+"\n");

       //From A to A, each neuron has 40 connection
       Output.writeBytes( Long.toString((int)(Math.random()*(AAAA-1)))+" " + 
	    Double.toString(WeightIn) + "\n");  }

       //From A to B, each neuron has one connection
       Output.writeBytes(  Long.toString(Math.round(Math.random()*(AAAA-1))+ AAAA)
	   +" " +Double.toString(WeightOut)+ "\n" );

    }

    //Create B pattern
    for ( int i= AAAA; i < 2*AAAA; i++ )  {
      Output.writeBytes( Integer.toString(i) + " " + "Neuron" + "\n");

      for (int j=0; j< NoOfConnection; j++ ) {
         if (j==0)
         Output.writeBytes( "80" + " " + "Axons"+"\n");

        //From B to B, each neuron has 40 connections
       Output.writeBytes(Long.toString(Math.round(Math.random()*(AAAA-1))+AAAA)
	   + " " + Double.toString(WeightIn) + "\n"); }

       //From B to C, each neuron has one connection.
       Output.writeBytes( Long.toString(Math.round(Math.random()*(AAAA-1))+2*AAAA)
	   +" " +Double.toString(WeightOut)+ "\n");

    }

    //Create C pattern
    for ( int i= 2*AAAA; i < 3*AAAA ; i++ )  {
      Output.writeBytes( Integer.toString(i) + " " + "Neuron" + "\n");

      for (int j=0; j< NoOfConnection ; j++ ) {
         if (j==0)
         Output.writeBytes( "80" + " " + "Axons"+"\n");

         // From C to C, each neuron has 40 connection
       Output.writeBytes( Long.toString(Math.round(Math.random()*(AAAA-1))+2*AAAA) 
	   +" " + Double.toString(WeightIn) + "\n"); }

         //From C to D
       Output.writeBytes(Long.toString(Math.round(Math.random()*(AAAA-1))+3*AAAA)
	   + " " + Double.toString(WeightOut)+ "\n");
    }

      //Create D pattern
    for ( int i= 3*AAAA; i < 4*AAAA; i++ )  {
      Output.writeBytes( Integer.toString(i) + " " + "Neuron" + "\n");

      for (int j=0; j< NoOfConnection ; j++ ) {
         if (j==0)
         Output.writeBytes( "80" + " "+ "Axons"+"\n");

         // From D to D, each neuron has 40 connections.
       Output.writeBytes(Long.toString(Math.round(Math.random()*(AAAA-1))+3*AAAA) 
	    +" "+ Double.toString(WeightIn) + "\n"); }

         //From D to A
       Output.writeBytes(Long.toString(Math.round(Math.random()*(AAAA-1))) 
	   + " " + Double.toString(WeightOut) + "\n");
      }

      Output.close();
  }
  catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);  }


}

public void Read() {
   DataInputStream DIS;
   String inputLine;

   InputStreamReader inputSR;
   LineNumberReader InputFile;
 
   
   try {
      DIS = new DataInputStream(new FileInputStream(NetFileName));
      inputSR = new InputStreamReader(DIS);
      InputFile = new LineNumberReader (inputSR);

      inputLine = InputFile.readLine();
      Rows=Integer.parseInt(inputLine);
      System.out.print ( Integer.toString(Rows) + "\n");

      inputLine= InputFile.readLine();
      Cols=Integer.parseInt(inputLine);
      System.out.print ( Integer.toString(Cols) + "\n");

      Initialize();

      for (int cNeurons=0; cNeurons < (Rows*Cols); cNeurons++) {
	  	Neurons[cNeurons].Read(InputFile);
		//System.out.println( cNeurons ); 
      }
	  
      InputFile.close();
	 
      }
     catch (IOException e) {
      System.err.println("input file not opened properly\n" +
                           e.toString());
      System.exit(1);}
	  FireNodes = new int[1000][Size()];
}

public void Write(){
   DataOutputStream Output;
   
   try {    
    Output = new DataOutputStream(new FileOutputStream(NetFileName));

    Output.writeBytes(Integer.toString(Rows)+"\n"+Integer.toString(Cols) +"\n");

    for ( int i=0;i<(Rows*Cols); i++ )  {
      Output.writeBytes( Integer.toString(i) + " Neuron\n");

      for (int j=0; j< Neurons[i].CurrentAxons ; j++ ) {
         if (j==0)
         Output.writeBytes( Integer.toString(Neurons[i].CurrentAxons) 
         + " Axons\n");

       Output.writeBytes(Integer.toString(Neurons[i].Axons[j].ToNeuron.ID) +
     " " +  Double.toString(Neurons[i].Axons[j].Weight) + "\n");
    }}

    Output.close();
  }
  catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);  }
}


public void printStringToFile(String outputString,
                              DataOutputStream outputStream){
   try {
      outputStream.writeBytes(outputString);
   }

   catch ( IOException e) {
      System.err.println("Error during output\n");
      System.exit(1);
   }
}

//print the average and variance of the weights in the range
//From to the range To
private void printRangeAxonalVariance (int startFrom, int endFrom,
                                       int startTo, int endTo) {
   double PositiveTotal=0.0,NegativeTotal=0.0;
   double PositiveAverage=0.0,NegativeAverage=0.0;
   double PositiveVariance=0.0, NegativeVariance=0.0;
   int cPositiveAxons=0,cNegativeAxons=0;
   String OutputString;

   //loop through all the neurons in From Range and calculate averages
   for (int cNeuron=startFrom; cNeuron <= endFrom; cNeuron++) {
      for (int cAxons=0; cAxons<Neurons[cNeuron].CurrentAxons; cAxons++) {
         if ((Neurons[cNeuron].Axons[cAxons].ToNeuron.ID >= startTo) &&
             (Neurons[cNeuron].Axons[cAxons].ToNeuron.ID <= endTo)) {
            if (Neurons[cNeuron].IsInhibitory) {
               cNegativeAxons++;
               NegativeTotal += Neurons[cNeuron].Axons[cAxons].Weight;
            }
            else {
               cPositiveAxons++;
               PositiveTotal += Neurons[cNeuron].Axons[cAxons].Weight;
            }
         }
      }
   }

   if (cPositiveAxons > 0)
      PositiveAverage = PositiveTotal/cPositiveAxons;
   if (cNegativeAxons > 0)
      NegativeAverage = NegativeTotal/cNegativeAxons;
   System.out.print (cPositiveAxons + " Pos Axons Average " + PositiveAverage +
      "\n");
   System.out.print (cNegativeAxons + " Neg Axons Average " + NegativeAverage +
      "\n");
   OutputString = Double.toString(PositiveAverage);
   OutputString = OutputString.substring(0,5);

   //calculate variance
   for (int cNeuron=startFrom; cNeuron <= endFrom; cNeuron++) {
      for (int cAxons=0; cAxons<Neurons[cNeuron].CurrentAxons; cAxons++) {
         if ((Neurons[cNeuron].Axons[cAxons].ToNeuron.ID >= startTo) &&
             (Neurons[cNeuron].Axons[cAxons].ToNeuron.ID <= endTo)) {
            if (Neurons[cNeuron].IsInhibitory) {
               NegativeVariance +=
                 Math.abs(Neurons[cNeuron].Axons[cAxons].Weight -
                    NegativeAverage);
            }
            else {
               PositiveVariance +=
                  Math.abs(Neurons[cNeuron].Axons[cAxons].Weight -
                    PositiveAverage);
            }
         }
      }
   }

   if (cPositiveAxons > 0)
      PositiveVariance = PositiveVariance/cPositiveAxons;
   if (cNegativeAxons > 0)
      NegativeVariance = NegativeVariance/cNegativeAxons;
   System.out.print ("Positive Variance " + PositiveVariance + "\n");
//   System.out.print ("Negative Variance " + NegativeVariance + "\n");
   OutputString = Double.toString(PositiveVariance);
   OutputString = OutputString.substring(0,5);
}

public void printAxonalPatternVariance(){
   printInpPat.PrintSharedWeights();
}

public void Clear(){
   for (int cNeuron = 0 ; cNeuron < Size(); cNeuron++)
      {
      Neurons[cNeuron].Clear();
      }
}

//-------------Functions that set or get Neuron values directly --------------
private void AddConnection(int From, int To, double Weight)
{
   //Assure no self connections
   if (To == From) return;

   assert(To < Size());
   if (Neurons[From].IsInhibitory)
      Neurons[From].AddConnection(Neurons[To],Weight*-1);
   else Neurons[From].AddConnection(Neurons[To],Weight);
}

//void Activate (int Neuron_Number);
private void Activate (int Neuron_Number, double Activation)
{
   assert(Neuron_Number < Size());
   Neurons[Neuron_Number].SetActivation(Activation);
}

public static int MeasureCo1 = (int) 20;
public static int MeasureCo2 = (int) 170;
public static int FireNodes[] [] ;

public double Measure(){
     double Correlation;
     double Sxx =0;
     double Syy =0;
     double Sxy =0;
     double MeanS;
     double MeanY;
     double Sx=0;
     double Sy=0;
	 
   if (!RecordingActivation) 
   {
      System.out.print("Recording Activation Off\n");
   }
   
     for ( int counter = 0; counter <Size(); counter++ )
           Sx += FireNodes[MeasureCo1][counter];
     MeanS = Sx/Size();

     for ( int counter = 0; counter < Size(); counter++ )
          { Sy += FireNodes[MeasureCo2][counter]; }
     MeanY = Sy/Size();

     for ( int counter = 0; counter <Size(); counter++ ) {
       Sxx += (FireNodes[MeasureCo1][counter]- MeanS)*(FireNodes[MeasureCo1][counter]- MeanS);
       Syy += (FireNodes[MeasureCo2][counter]- MeanY)*(FireNodes[MeasureCo2][counter]- MeanY);
       Sxy += (FireNodes[MeasureCo1][counter]- MeanS)*(FireNodes[MeasureCo2][counter]- MeanY); }

     Correlation = Sxy/(Math.sqrt (Sxx*Syy));
	 return Correlation;

   }


public int GetActives()
{
   int TotalActives = 0;
   for (int index = 0; index < Size(); index++)
   {
      if (Neurons[index].Fired)
        {
	  /*System.out.print ( Integer.toString(index) +  ' ' +
          Neurons[index].PriorActivation + '\n'); */
		if (RecordingActivation)
           FireNodes[CANTStep%1000][index] = 1;
		
		   TotalActives++;   
        }

       else if (RecordingActivation)
	     FireNodes[CANTStep%1000][index] = 0;
     }


   return TotalActives;
	  
}
 
private void PrintActives()
{
   int TotalActives = GetActives();

  System.out.print ( " Active_Nodes "+ 
      Integer.toString(CANTStep) + " " + 
	  Integer.toString (TotalActives) + '\n');
	  
	  
//System.out.print (Neurons[0].Axons[0].Weight + "\n");


}

private  DataOutputStream outputActivesFile;
private void PrintActivesToFile(String FileName)
{
   //open the file
   try {
      outputActivesFile = new DataOutputStream(
         new FileOutputStream(FileName));
   }
   catch (IOException e) {
      System.err.println("output file not opened properly\n" +
                           e.toString());
      System.exit(1);
   }

   printStringToFile("400 \n",outputActivesFile);

   for (int index = 0; index < Size(); index++)
   {
      if (Neurons[index].Fired){
         printStringToFile("1 \n",outputActivesFile);
      }
      else {
         printStringToFile("0 \n",outputActivesFile);
      }
   }

   //close the file
   try {
      outputActivesFile.close();
   }
   catch (IOException io) {
      System.err.println("crashed closing output file\n");
      System.exit(1);
   }
}

//----------------------------------
//Return the left neigbor in a 2d space.
public int GetLeftNeighbor(int NeuronID)
{
   if ((NeuronID % Cols) == 0)
      return (NeuronID + Cols - 1);
   else
      return (NeuronID - 1);
}

//Return the right neigbor in a 2d space.
public int GetRightNeighbor(int NeuronID)
{
   if ((NeuronID % Cols) == (Cols -1))
      return (NeuronID - Cols + 1);
   else
      return (NeuronID + 1);
}

//Return the top neigbor in a 2d space.
public int GetTopNeighbor(int NeuronID)
{
   if (NeuronID < Cols)
      return (NeuronID + ((Rows-1) * Cols));
   else
      return (NeuronID - Cols);
}

//Return the bottom neigbor in a 2d space.
public int GetBottomNeighbor(int NeuronID)
{
   if ((NeuronID / Cols) == (Rows -1))
      return (NeuronID - ((Rows-1) * Cols));
   else
      return (NeuronID + Cols);
}
//----------------------------------
//Set up nets

//Set up a net with a particular topology depending on type
public void SetConnections(int StartNeuron, int EndNeuron, int Type)
{
   int FromNeuron;
   int cNeurons = Size();
   

   assert(cNeurons >= EndNeuron);
   //For Each Neuron
   if (Type == 1) {
      for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
         if ((FromNeuron%10) == 0) 	  {
            AddConnection(FromNeuron,FromNeuron+1,1.4);
            AddConnection(FromNeuron,FromNeuron+9,1.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.8);
            AddConnection(FromNeuron,FromNeuron+8,-0.8);
         }
         else if ((FromNeuron%10) == 1) 	  {
            AddConnection(FromNeuron,FromNeuron+1,1.4);
            AddConnection(FromNeuron,FromNeuron-1,1.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.8);
            AddConnection(FromNeuron,FromNeuron+8,-0.8);
         }
         else if ((FromNeuron%10) == 8) 	  {
            AddConnection(FromNeuron,FromNeuron+1,1.4);
            AddConnection(FromNeuron,FromNeuron-1,1.4);
            AddConnection(FromNeuron,FromNeuron-8,-0.8);
            AddConnection(FromNeuron,FromNeuron-2,-0.8);
         }
         else if ((FromNeuron%10) == 9) 	  {
            AddConnection(FromNeuron,FromNeuron-9,1.4);
            AddConnection(FromNeuron,FromNeuron-1,1.4);
            AddConnection(FromNeuron,FromNeuron-8,-0.8);
            AddConnection(FromNeuron,FromNeuron-2,-0.8);
         }
         else {
            AddConnection(FromNeuron,FromNeuron+1,1.4);
            AddConnection(FromNeuron,FromNeuron-1,1.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.8);
            AddConnection(FromNeuron,FromNeuron-2,-0.8);
         }
      }	
   }
   if (Type == 2)    {
      for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
         if ((FromNeuron%10) == 0) 	  {
            AddConnection(FromNeuron,FromNeuron+1,0.4);
            AddConnection(FromNeuron,FromNeuron+9,0.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.4);
            AddConnection(FromNeuron,FromNeuron+8,-0.4);
         }
         else if ((FromNeuron%10) == 1) 	  {
            AddConnection(FromNeuron,FromNeuron+1,0.4);
            AddConnection(FromNeuron,FromNeuron-1,0.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.4);
            AddConnection(FromNeuron,FromNeuron+8,-0.4);
         }
         else if ((FromNeuron%10) == 8) 	  {
            AddConnection(FromNeuron,FromNeuron+1,0.4);
            AddConnection(FromNeuron,FromNeuron-1,0.4);
            AddConnection(FromNeuron,FromNeuron-8,-0.4);
            AddConnection(FromNeuron,FromNeuron-2,-0.4);
         }
         else if ((FromNeuron%10) == 9) 	  {
            AddConnection(FromNeuron,FromNeuron-9,0.4);
            AddConnection(FromNeuron,FromNeuron-1,0.4);
            AddConnection(FromNeuron,FromNeuron-8,-0.4);
            AddConnection(FromNeuron,FromNeuron-2,-0.4);
         }
         else {
            AddConnection(FromNeuron,FromNeuron+1,0.4);
            AddConnection(FromNeuron,FromNeuron-1,0.4);
            AddConnection(FromNeuron,FromNeuron+2,-0.4);
            AddConnection(FromNeuron,FromNeuron-2,-0.4);
         }
      }	
      for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
         AddConnection(FromNeuron,(FromNeuron+20)%cNeurons,0.6);
		 if (FromNeuron <20)
            AddConnection(FromNeuron,FromNeuron+(cNeurons-20),0.6);
         else
		    AddConnection(FromNeuron,FromNeuron-20,0.6);
      }			
   }
   else if (Type == 3)    {
      for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
         int Row = FromNeuron/Rows;
		 int Col = FromNeuron%Rows;
		 //inhibitory neuron
		 if ((Row%4) == 1) {
		 	int PatternCol = (FromNeuron%10);
			int RightNeuron = ((PatternCol+2)%10)+(FromNeuron-PatternCol);
			int LeftNeuron = (PatternCol-2);
			if (LeftNeuron < 0) LeftNeuron += 10;
			LeftNeuron += (FromNeuron-PatternCol);
            AddConnection(FromNeuron,RightNeuron,-0.4);
            AddConnection(FromNeuron,LeftNeuron,-0.4);
		    AddConnection(FromNeuron,RightNeuron+Cols,-0.4);
			AddConnection(FromNeuron,LeftNeuron+Cols,-0.4);
			AddConnection(FromNeuron,RightNeuron-Cols,-0.4);
			AddConnection(FromNeuron,LeftNeuron-Cols,-0.4);
			AddConnection(FromNeuron,RightNeuron+(2*Cols),-0.4);
			AddConnection(FromNeuron,LeftNeuron+(2*Cols),-0.4);
		 }
		 else {
            int PatternCol = (FromNeuron%10);
		    int RightNeuron = ((PatternCol+1)%10)+(FromNeuron-PatternCol);
		    int LeftNeuron = (PatternCol-1);
            if (LeftNeuron < 0) LeftNeuron += 10;
		    LeftNeuron += (FromNeuron-PatternCol);
            AddConnection(FromNeuron,RightNeuron,0.4);
		    AddConnection(FromNeuron,LeftNeuron,0.4);
		    AddConnection(FromNeuron,(FromNeuron+Cols)%EndNeuron,0.6);
		    if ((Row%4) == 0) {
		       AddConnection(FromNeuron,FromNeuron+(2*Cols),0.6);
		    }  
		 }
      }	
   }
   else if (Type == 4)    {
      for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
         int Row = FromNeuron/Rows;
   	     int Col = FromNeuron%Rows;
   	     //inhibitory neuron
   	     if ((Row%4) == 1) {
   	 	    int PatternCol = (FromNeuron%10);
   		    int RightNeuron = ((PatternCol+2)%10)+(FromNeuron-PatternCol);
   		    int LeftNeuron = (PatternCol-2);
   		    if (LeftNeuron < 0) LeftNeuron += 10;
   		       LeftNeuron += (FromNeuron-PatternCol);
               AddConnection(FromNeuron,RightNeuron,-0.4);
               AddConnection(FromNeuron,LeftNeuron,-0.4);
   	           AddConnection(FromNeuron,RightNeuron+Cols,-0.4);
   		       AddConnection(FromNeuron,LeftNeuron+Cols,-0.4);
   		       AddConnection(FromNeuron,RightNeuron-Cols,-0.4);
   		       AddConnection(FromNeuron,LeftNeuron-Cols,-0.4);
   		       AddConnection(FromNeuron,RightNeuron+(2*Cols),-0.4);
   		       AddConnection(FromNeuron,LeftNeuron+(2*Cols),-0.4);
   	     }
   	     else {
            int PatternCol = (FromNeuron%10);
   	        int RightNeuron = ((PatternCol+1)%10)+(FromNeuron-PatternCol);
   	        int LeftNeuron = (PatternCol-1);
               if (LeftNeuron < 0) LeftNeuron += 10;
   	               LeftNeuron += (FromNeuron-PatternCol);
                   AddConnection(FromNeuron,RightNeuron,0.4);
   	               AddConnection(FromNeuron,LeftNeuron,0.4);
   	               AddConnection(FromNeuron,(FromNeuron+Cols)%EndNeuron,0.4);
   	               if ((Row%4) == 0) {
   	                  AddConnection(FromNeuron,FromNeuron+(2*Cols),0.4);
   	                  AddConnection(FromNeuron,RightNeuron+Cols,0.2);
   	                  AddConnection(FromNeuron,LeftNeuron+(2*Cols),0.2);
   	               }
   	               else if ((Row%4) == 2) {
   	                  AddConnection(FromNeuron,FromNeuron-Cols,0.4);
   	                  AddConnection(FromNeuron,RightNeuron+Cols,0.2);
   	               }
   	               else if ((Row%4) == 3) {
   	                  AddConnection(FromNeuron,(LeftNeuron+Cols)%EndNeuron,0.2);
   	               }  
   	     }
      }	
   }
   //The dog, cat etc. Hopfield
   else if ((Type ==5) || (Type == 6))
   {
   for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
   	  int HoppNumber = FromNeuron%10;
      if (Type == 6) 
	     AddConnection(FromNeuron,(FromNeuron+10)%(Cols*Rows),0.3);
      if (HoppNumber == 0)
         {
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,-0.3);
         AddConnection(FromNeuron,FromNeuron+3,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         }
      else if (HoppNumber == 1)
         {
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         AddConnection(FromNeuron,FromNeuron+8,0.7);
         }
      else if (HoppNumber == 2)
         {
         AddConnection(FromNeuron,FromNeuron-2,-0.3);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         }
      else if (HoppNumber == 3)
         {
         AddConnection(FromNeuron,FromNeuron-3,0.2);
         AddConnection(FromNeuron,FromNeuron-2,0.2);
         AddConnection(FromNeuron,FromNeuron-1,0.2);
         AddConnection(FromNeuron,FromNeuron+1,0.7);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         }
      else if (HoppNumber == 4)
         {
         AddConnection(FromNeuron,FromNeuron-1,0.7);
         }
      else if (HoppNumber == 5)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,-0.3);
         }
      else if (HoppNumber == 6)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         }
      else if (HoppNumber == 7)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron-2,-0.3);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         }
      else if (HoppNumber == 8)
         {
         AddConnection(FromNeuron,FromNeuron-4,0.7);
         AddConnection(FromNeuron,FromNeuron+1,-0.5);
         }
      else if (HoppNumber == 9)
         {
         AddConnection(FromNeuron,FromNeuron-8,0.7);
         AddConnection(FromNeuron,FromNeuron-1,-0.7);
         }
      }
   }
   else if (Type ==7)
   {
   for (FromNeuron = StartNeuron; FromNeuron < EndNeuron;FromNeuron ++) {
   	  int HoppNumber = FromNeuron%10;
      AddConnection(FromNeuron,(FromNeuron+10)%(Cols*Rows),0.3);
/*	  if (FromNeuron < 10) 
         AddConnection(FromNeuron,(FromNeuron+(Cols*Rows)-10),0.3);
	  else 
         AddConnection(FromNeuron,(FromNeuron-10),0.3);
*/      if (HoppNumber == 0)
         {
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,-0.3);
         AddConnection(FromNeuron,FromNeuron+3,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         AddConnection(FromNeuron,(FromNeuron+15)%(Cols*Rows),0.3);
         }
      else if (HoppNumber == 1)
         {
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         AddConnection(FromNeuron,FromNeuron+8,0.7);
         AddConnection(FromNeuron,(FromNeuron+15)%(Cols*Rows),0.3);
         }
      else if (HoppNumber == 2)
         {
         AddConnection(FromNeuron,FromNeuron-2,-0.3);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,0.2);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         AddConnection(FromNeuron,(FromNeuron+15)%(Cols*Rows),0.3);
         }
      else if (HoppNumber == 3)
         {
         AddConnection(FromNeuron,FromNeuron-3,0.2);
         AddConnection(FromNeuron,FromNeuron-2,0.2);
         AddConnection(FromNeuron,FromNeuron-1,0.2);
         AddConnection(FromNeuron,FromNeuron+1,0.7);
         AddConnection(FromNeuron,FromNeuron+5,0.7);
         }
      else if (HoppNumber == 4)
         {
         AddConnection(FromNeuron,FromNeuron-1,0.7);
         }
      else if (HoppNumber == 5)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         AddConnection(FromNeuron,FromNeuron+2,-0.3);
         }
      else if (HoppNumber == 6)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         AddConnection(FromNeuron,FromNeuron+1,-0.3);
         }
      else if (HoppNumber == 7)
         {
         AddConnection(FromNeuron,FromNeuron-5,0.7);
         AddConnection(FromNeuron,FromNeuron-2,-0.3);
         AddConnection(FromNeuron,FromNeuron-1,-0.3);
         }
      else if (HoppNumber == 8)
         {
         AddConnection(FromNeuron,FromNeuron-4,0.7);
         AddConnection(FromNeuron,FromNeuron+1,-0.5);
         }
      else if (HoppNumber == 9)
         {
         AddConnection(FromNeuron,FromNeuron-8,0.7);
         AddConnection(FromNeuron,FromNeuron-1,-0.7);
         }
      }
   }
   else assert (Type == 1);
}

//Weight setting is just for a calculated version
private double GetPresetWeights (int FromNeuron, int ToNeuron) 
{
	int FromClass = FromNeuron % 10;
	int ToClass = ToNeuron % 10;
	 
	if (FromClass == 0)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 1) return 0.7; 
          else if (ToClass == 2) return 0.7; 
	   }
	   else 
	   {
          if (ToClass == 0) return 0.3;
          else if (ToClass == 3) return 0.1; 
          else if (ToClass == 5) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 1)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 0) return 0.7; 
          else if (ToClass == 2) return 0.7; 
	   }
	   else 
	   {
          if (ToClass == 1) return 0.3;
          else if (ToClass == 3) return 0.1; 
          else if (ToClass == 6) return 0.3; 
          else if (ToClass == 9) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 2)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 0) return 0.7; 
          else if (ToClass == 1) return 0.7; 
	   }
	   else 
	   {
          if (ToClass == 2) return 0.3;
          else if (ToClass == 3) return 0.1; 
          else if (ToClass == 7) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 3)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          return 0.; 
	   }
	   else 
	   {
          if (ToClass == 3) return 0.3;
          else if (ToClass == 0) return 0.05; 
          else if (ToClass == 1) return 0.05; 
          else if (ToClass == 2) return 0.05; 
          else if (ToClass == 4) return 0.3; 
          else if (ToClass == 8) return 0.2; 
       }
	   return 0.0;
    }
	else if (FromClass == 4)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          return 0.; 
	   }
	   else 
	   {
          if (ToClass == 4) return 0.3;
          else if (ToClass == 3) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 5)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 6) return 0.9;
          else if (ToClass == 7) return 0.9; 
	   }
	   else 
	   {
          if (ToClass == 5) return 0.3;
          else if (ToClass == 0) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 6)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 5) return 0.9;
          else if (ToClass == 7) return 0.9; 
	   }
	   else 
	   {
          if (ToClass == 6) return 0.3;
          else if (ToClass == 1) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 7)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 5) return 0.9;
          else if (ToClass == 6) return 0.9; 
	   }
	   else 
	   {
          if (ToClass == 7) return 0.3;
          else if (ToClass == 2) return 0.3; 
       }
	   return 0.0;
    }
	else if (FromClass == 8)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 9) return 0.9;
	   }
	   else 
	   {
          if (ToClass == 8) return 0.3;
          else if (ToClass == 3) return 0.1; 
       }
	   return 0.0;
    }
	else if (FromClass == 9)
    {
       if (Neurons[FromNeuron].IsInhibitory())
	   {
          if (ToClass == 8) return 0.9;
	   }
	   else 
	   {
          if (ToClass == 9) return 0.3;
          else if (ToClass == 1) return 0.2; 
       }
	   return 0.0;
    }
	else 
	{
	   assert (ToClass == 0); 
	   return 0.0;
	}
}

//Set up a distance bias set of
//connections.  Assume that the Neurons are
//in a 2-D space.  Those next to it (lr and td) are
//likely to be connected, next step away less so.
public void SetConnections(int StartNeuron, int EndNeuron)
{
   int CurrentFromNeuron;
   int N1 = -1,N2 = -1,N3 = -1,N4 = -1;
   int cNeurons = Size();

   assert(cNeurons >= EndNeuron);

   //For Each Neuron
   for (CurrentFromNeuron = StartNeuron ; CurrentFromNeuron < EndNeuron;
        CurrentFromNeuron ++) {
/*
      if (Neurons[CurrentFromNeuron].IsInhibitory())
         SetInhibitoryConnections(CurrentFromNeuron);
      else 
*/
	     {
         //Get it's neighbors
         //Make N1 a long distance connection
         N1 = (int)(N1 + (Math.random() * Size()))%Size();
         //N1 = GetLeftNeighbor(CurrentFromNeuron);
         N2 = GetRightNeighbor(CurrentFromNeuron);
         N3 = GetTopNeighbor(CurrentFromNeuron);
         N4 = GetBottomNeighbor(CurrentFromNeuron);
         RecursiveSetConnections(CurrentFromNeuron,N1,1);
         RecursiveSetConnections(CurrentFromNeuron,N2,1);
         RecursiveSetConnections(CurrentFromNeuron,N3,1);
         RecursiveSetConnections(CurrentFromNeuron,N4,1);

/*Connect Randomly
		 for (int i=0; i < 40;i++)
		    {
		    float Weight = (float)(((Math.random()) + 1) * Conn_Str);
			AddConnection(CurrentFromNeuron,
			             (int)((Math.random() * Size()) % Size()),
			              Weight);
			
		    }
*/

		 	
         }
   }
}

	
//Set the connection strength of this axon, then recursively
//call to set up connections (at a lower likelihood) to other connections.
private void RecursiveSetConnections (int FromNeuron, int ToNeuron, int Distance)
{
   int N1,N2,N3,N4;
   //neighboring neurons
   double Weight;

   //Set up the initial Weight
   Weight = (float)(((Math.random()) + 1) * Conn_Str);
//   Weight = GetPresetWeights(FromNeuron, ToNeuron);

   //with a probability lessening as distance increases
   //set the connection from to
   if (Math.random() < (1.0 / (Distance * CONNECTIVITY)))
      AddConnection(FromNeuron,ToNeuron,Weight);

   //call for children if they're close.
   if (Distance < 4)
      {
      //call for children
      N1 = GetLeftNeighbor(ToNeuron);
      N2 = GetRightNeighbor(ToNeuron);
      N3 = GetTopNeighbor(ToNeuron);
      N4 = GetBottomNeighbor(ToNeuron);
      RecursiveSetConnections(FromNeuron,N1,Distance + 1);
      RecursiveSetConnections(FromNeuron,N2,Distance + 1);
      RecursiveSetConnections(FromNeuron,N3,Distance + 1);
      RecursiveSetConnections(FromNeuron,N4,Distance + 1);
      }
}

private void SetInhibitoryConnections(int FromNeuron){
   float Weight = (float) 0.0;
   int ToNeuron;

   for (int AxonNum = 0; AxonNum < INHIBITORY_SYNAPSES; AxonNum ++) {
      ToNeuron = (int)Math.floor(Math.random() * Size());
      //setup weight
      Weight = (float)(((Math.random()) + 1) * Conn_Str);

      AddConnection(FromNeuron,ToNeuron,Weight);
   }
}

//Print out the strength of each neuron to the screen
void PrintWeights() {
   int TotalNeurons = Size();
   double NeuralStrength;

   for (int NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
      {
      NeuralStrength = Neurons[NeuronIndex].GetTotalConnectionStrength();
      System.out.print ("Neuron " + NeuronIndex + "  " + NeuralStrength + '\n');
      }
}

void PrintConnections() {
   int TotalNeurons = Size();
   int TotalPosAxons=0, TotalNegAxons=0;
   float TotalPosStrength=(float)0.0;
   float TotalNegStrength=(float)0.0;

   for (int NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
      {
      if (Neurons[NeuronIndex].IsInhibitory)
         {
         TotalNegAxons += Neurons[NeuronIndex].CurrentAxons;
         TotalNegStrength += Neurons[NeuronIndex].GetTotalConnectionStrength();
         }
      else
         {
         TotalPosAxons += Neurons[NeuronIndex].CurrentAxons;
         TotalPosStrength += Neurons[NeuronIndex].GetTotalConnectionStrength();
         }
      }

  System.out.print (TotalPosAxons + " pos neg " + TotalNegAxons + '\n');
  System.out.print (TotalPosStrength + " pos neg " + TotalNegStrength + '\n');
}

private void SetExternalActivation(Inppat activationPattern, int cycleNumber,
                                   int numberToActivate)
{
   int activePatternEl;
   
   activationPattern.SetInputPattern(cycleNumber);
   

   if ((cycleNumber%activationPattern.CYCLESPERRUN > 20) && 
      (AllowRunOn)) return;

   for (int i= 0; i < numberToActivate; i++) 
   {
      assert (numberToActivate <= activationPattern.get_elements_in_pattern());
//System.out.print ("cpv " + activationPattern.curPatternVariant + '\n');
//System.out.print ("" + activationPattern.pattern
//	     [activationPattern.curPatternVariant][i] + '\n');
      this.Activate(activationPattern.pattern
	     [activationPattern.curPatternVariant][i],
         (3+ACTIVATION_THRESHOLD+(Math.random()*ACTIVATION_THRESHOLD)));
//         (ACTIVATION_THRESHOLD+(Math.random()*ACTIVATION_THRESHOLD)));
   }
}

//void WarmUp();

private void Learn() {
   if (!LearningOn) return;

   int TotalNeurons = Size();

   for (int NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
      Neurons[NeuronIndex].Learn(); 
   }
   
//      Neurons[NeuronIndex].Learn2();
  
   

//New activation may have come externally.  Current is that activation +
//any remaining from last time.
private void PropogateChange()
{
   int NeuronIndex;
   int TotalNeurons = Size();

   //spontaneously activate
   for (NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++) {
      if (Neurons[NeuronIndex].SpontaneouslyActivate())
         this.Activate(NeuronIndex,(ACTIVATION_THRESHOLD*2));
   }

   //Set whether neuron has fired.
   for (NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
      Neurons[NeuronIndex].SetFired();

   //resetActivation and apply decay
   for (NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
      Neurons[NeuronIndex].ResetActivation();

   //for each formally active neuron spread activation
   for (NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++)
   {
      if ((!Net.AssociationTest) && (Neurons[NeuronIndex].Fired))
	  {	  
         Neurons[NeuronIndex].SpreadActivation();
	  }
   }

   //modify fatigue
   if (NeuronsFatigue)
      for (NeuronIndex = 0; NeuronIndex < TotalNeurons; NeuronIndex++) {
         Neurons[NeuronIndex].ModifyFatigue();
      }
}


void PrintNet(int Step, Inppat inputPattern)
{
   PrintActives();
/*
   if ((Step % 1000) == 500)
      if (RecordingActivation) 
	  {
         MeasureCo1 = 5;
         MeasureCo2 = 155;
         Measure();
         MeasureCo1 = 55;
         MeasureCo2 = 205;
         Measure();
         MeasureCo1 = 105;
         MeasureCo2 = 255;
         Measure();
         MeasureCo1 = 5;
         MeasureCo2 = 55;
         Measure();
         MeasureCo2 = 105;
	     Measure();
         MeasureCo1 = 105;
	     MeasureCo2 = 155;
         Measure();
	  }
*/	  
}

//-----The functions to Run----
public void RunOneStep(Inppat inputPattern)
{
//   System.out.print ("Cycle " + CANTStep + ' ');
//   if ((CANTStep%100) == 0) printAxonalPatternVariance();
   SetExternalActivation(inputPattern,CANTStep,NeuronsToStimulate);

   PropogateChange();
   Learn();
   PrintNet(CANTStep,inputPattern);

   CANTStep++;
}


public void Run()
{
   int Iterations = 0;
   Inppat inputPattern = new Inppat();
   
   while ((Iterations < NUMBERCYCLES))
      {
      System.out.print ("Iteration " + Integer.toString(Iterations++) + ' ');
      RunOneStep(inputPattern);
      }
}
//void Run(input_pattern Activation_Pattern,int Number_To_Activate);
//void Run(input_pattern Activation_PatternA,input_pattern Activation_PatternB,int Number_To_Activate);

};
